﻿using System.Collections.Generic;
using System.Linq;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Data;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace StateSwitching
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
            var countryGroups =
            from item in SourceData.GetData()
            group item by item.Country into countryGroup
            select new CountryGroup(FlattenedTownGroupsForCountry(countryGroup))
            {
                Country = countryGroup.Key
            };

            var cvs = (CollectionViewSource) Resources["src"];
            cvs.Source = countryGroups.ToList();
        }

        public static IEnumerable<object> ItemsForTownGroup(IGrouping<string, SourceData> townGroup)
        {
            object[] groupItemAsList = { new TownGroup { Town = townGroup.Key } };
            return groupItemAsList.Concat(townGroup);
        }

        public static IEnumerable<object> FlattenedTownGroupsForCountry(IEnumerable<SourceData> countryGroup)
        {
            return countryGroup.GroupBy(item => item.Town).SelectMany(ItemsForTownGroup);
        }
    }
}
