﻿using System.Collections.Generic;
using System.Linq;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace StateSwitching
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();

            this.NavigationCacheMode = NavigationCacheMode.Required;
            var countryGroups =
                    from item in SourceData.GetData()
                    group item by item.Country into countryGroup
                    select new CountryGroup(FlattenedTownGroupsForCountry(countryGroup))
                    {
                        Country = countryGroup.Key
                    };

            var cvs = (CollectionViewSource) Resources["src"];
            cvs.Source = countryGroups.ToList();
        }

        public static IEnumerable<object> ItemsForTownGroup(IGrouping<string, SourceData> townGroup)
        {
            object[] groupItemAsList = { new TownGroup { Town = townGroup.Key } };
            return groupItemAsList.Concat(townGroup);
        }

        public static IEnumerable<object> FlattenedTownGroupsForCountry(IEnumerable<SourceData> countryGroup)
        {
            return countryGroup.GroupBy(item => item.Town).SelectMany(ItemsForTownGroup);
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.
        /// This parameter is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            // TODO: Prepare page for display here.

            // TODO: If your application contains multiple pages, ensure that you are
            // handling the hardware Back button by registering for the
            // Windows.Phone.UI.Input.HardwareButtons.BackPressed event.
            // If you are using the NavigationHelper provided by some templates,
            // this event is handled for you.
        }
    }
}
